<template>
  <v-card
    class="mx-auto"
    outlined
  >
    <v-form class="my-7">
      <v-row no-gutters justify="center">
        <v-col cols="4">
          <v-text-field
            v-model="name"
            label="Nombre"
            :rules="nameRules"
            counter="100"
            required
            outlined
          />
          <v-text-field
            v-model="address"
            label="Dirección"
            :rules="addressRules"
            counter="100"
            required
            outlined
          />
          <v-text-field
            label="Ubicación geográfica"
            :rules="locationRules"
            required
            outlined
          />
          <option-btns
            @cancel="returnToCenters"
            @register="registerAndReturn"
          />
        </v-col>
      </v-row>
    </v-form>
  </v-card>
</template>

<script>
import { mapActions } from 'vuex';
import OptionBtns from '~/components/Common/Form/OptionBtns';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'NewCenterForm',
  components: {
    OptionBtns,
  },
  data: () => ({
    name: '',
    address: '',
    location: {},
    nameRules: [],
    addressRules: [],
    locationRules: [],
  }),
  methods: {
    ...mapActions({
      registerNewCenter: 'company/centers/registerNewCenter',
    }),
    returnToCenters() {
      this.$router.push('/empresa/centros');
    },
    async registerAndReturn() {
      try {
        const { name, address, location } = this;
        await this.registerNewCenter({ name, address, location });
        this.$toast.success('Se ha registrado el nuevo centro correctamente', successOptions);
        await this.returnToCenters();
      } catch (e) {
        this.$toast.error('No se ha podido registrar el centro de distribución', errorOptions);
      }
    },
  },
};
</script>
